package uu_default_config;
use strict; 
use Exporter;

@uu_default_config::ISA = qw( Exporter );
@uu_default_config::EXPORT = qw($config);

use vars qw($config);

$config = {
	config_file_name         => 'uu_default_config',
	temp_dir                 => '/tmp/',
	upload_dir               => $ENV{'DOCUMENT_ROOT'} . '/uploads/',
	unique_upload_dir        => 0,
	unique_upload_dir_length => 16,
	unique_file_name         => 0,
	unique_file_name_length  => 16,
	max_upload               => 5242880,
	overwrite_existing_files => 0,
	redirect_after_upload    => 0,
	redirect_url             => 'http://' . $ENV{'SERVER_NAME'} . '/uu_finished.php',
	redirect_using_js_html   => 1,
	redirect_using_html      => 0,
	redirect_using_js        => 0,
	redirect_using_location  => 0,
	get_data_speed           => 1000,
	disallow_extensions      => '(sh|php|php3|php4|php5|py|shtml|phtml|cgi|pl|plx|htaccess|htpasswd)',
	allow_extensions         => '(jpg|jpeg|gif|bmp)',
	normalize_file_names     => 1,
	normalize_file_delimiter => '_',
	normalize_file_length    => 48,
	link_to_upload           => 0,
	path_to_upload           => 'http://'. $ENV{'SERVER_NAME'} . '/uploads/',
	send_email_on_upload     => 0,
	html_email_support       => 0,
	link_to_upload_in_email  => 0,
	email_subject            => 'Uber File Upload',
	to_email_address         => 'email_1@somewhere.com,email_2@somewhere.com',
	from_email_address       => 'admin@yoursite.com',
	log_uploads              => 0,
	log_params               => 0,
	log_dir                  => '/tmp/uu_logs/',
};

1;
