<?php
//******************************************************************************************************
//   ATTENTION: THIS FILE HEADER MUST REMAIN INTACT. DO NOT DELETE OR MODIFY THIS FILE HEADER.
//
//   Name: uu_finished.php
//   Revision: 6.0
//   Date: 22/09/2007 3:10PM
//   Link: http://uber-uploader.sourceforge.net 
//   Initial Developer: Peter Schmandra  http://www.webdice.org
//   Description: Show successful file uploads.
//   Note: Pop ups may need to be enabled in the browser in order for this file to close the progress bar
//
//   Licence:
//   The contents of this file are subject to the Mozilla Public
//   License Version 1.1 (the "License"); you may not use this file
//   except in compliance with the License. You may obtain a copy of
//   the License at http://www.mozilla.org/MPL/
// 
//   Software distributed under the License is distributed on an "AS
//   IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
//   implied. See the License for the specific language governing
//   rights and limitations under the License.
//
//   NOTE: THIS FILE IS ONLY NECESSARY IF YOU ARE USING THE 'redirect_after_upload' CONFIG SETTING.
//
//***************************************************************************************************************
header('Content-type: text/html; charset=UTF-8');
header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
header('Last-Modified: '.date('r'));
header('Cache-Control: no-store, no-cache, must-revalidate');
header('Cache-Control: post-check=0, pre-check=0', FALSE);
header('Pragma: no-cache');

require "uu_conlib.php"; 
require "uu_finished_lib.php";

$THIS_VERSION = "6.0";                                // Version of this file
$DEBUG_ENABLED = 0;                                   // Display all data read from the sid.xml file and exit
$DELETE_XML_FILE = 1;                                 // Delete the sid.xml file when finished parsing

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// The following possible query string formats are assumed
//
// 1. ?temp_sid=random_sid_number&temp_dir=path_to_temp_dir
// 2. ?temp_sid=random_sid_number (NOTE: Only works if 'TEMP_DIR' is hardcoded and 'uu_upload.pl' is modified to not send it in the query string.)
// 3. ?cmd=about
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Check for 'about' command or valid SID
if(isset($_GET['cmd']) && $_GET['cmd'] == 'about'){ kak("<u><b>UBER UPLOADER FINISHED PAGE</b></u><br>UBER UPLOADER VERSION =  <b>" . $UBER_VERSION . "</b><br>UU_FINISHED = <b>" . $THIS_VERSION . "<b><br>\n"); }
elseif(!preg_match("/^[a-zA-Z0-9]{32}$/", $_REQUEST['temp_sid'])){ kak("<font color='red'>WARNING</font>: Invalid session-id.<br>\n"); }

//Declare local values
$TEMP_DIR = $_REQUEST['temp_dir'];                    // Hardcode the 'TEMP_DIR' value here instead of passing it in the address bar. Note: Must also edit 'uu_upload.pl'.
$TEMP_SID = $_REQUEST['temp_sid'];                    // Store the sid number
$_XML_DATA = array();                                 // Array of xml data read from the sid.xml file
$_CONFIG_DATA = array();                              // Array of config data read from the $_XML_DATA array
$_POST_DATA = array();                                // Array of posted data read from the $_XML_DATA array
$_FILE_DATA = array();                                // Array of 'FileInfo' objects read from the $_XML_DATA array
$_FILE_DATA_TABLE = '';                               // String used to store file info results nested between <tr> tags
$_FILE_DATA_EMAIL = '';                               // String used to store file info results

$xml_parser = new XML_Parser;                         // XML parser
$xml_parser->setXMLFile($TEMP_DIR, $TEMP_SID);        // Set sid.xml file
$xml_parser->setXMLFileDelete($DELETE_XML_FILE);      // Delete sid.xml file when finished parsing
$xml_parser->parseFeed();                             // Parse sid.xml file

// Display message if the XML parser encountered an error 
if($xml_parser->getError()){ kak($xml_parser->getErrorMsg()); }

$_XML_DATA = $xml_parser->getXMLData();               // Get xml data from the xml parser
$_CONFIG_DATA = getConfigData($_XML_DATA);            // Get config data from the xml data
$_POST_DATA  = getPostData($_XML_DATA);               // Get post data from the xml data
$_FILE_DATA = getFileData($_XML_DATA);                // Get file data from the xml data


// Output XML DATA, CONFIG DATA, POST DATA, FILE DATA to screen and exit if DEBUG_ENABLED.
if($DEBUG_ENABLED){
	debug("<br><u>XML DATA</u>", $_XML_DATA);
	debug("<u>CONFIG DATA</u>", $_CONFIG_DATA);
	debug("<u>POST DATA</u>", $_POST_DATA);
	debug("<u>FILE DATA</u><br>", $_FILE_DATA);
	exit;
}





/////////////////////////////////////////////////////////////////////////////////////////////////
//
//           *** ATTENTION: ENTER YOUR CODE HERE !!! ***
//
// This is a good place to put your code. Like saving the
// uploaded file information to your DB or doing some image 
// manipulation. etc. Everything you need is in the 
// $_CONFIG_DATA, $_POST_DATA and $_FILE_DATA arrays.
//
/////////////////////////////////////////////////////////////////////////////////////////////////
// NOTE: You can now access all config values below this comment. eg. 
//   $_CONFIG_DATA['upload_dir']; or $_CONFIG_DATA['link_to_upload'] etc
/////////////////////////////////////////////////////////////////////////////////////////////////
// NOTE: You can now access all post values below this comment. eg. 
//   $_POST_DATA['client_id']; or $_POST_DATA['check_box_1_'] etc
/////////////////////////////////////////////////////////////////////////////////////////////////
// NOTE: You can now access all file (slot, name, size, type) info below this comment. eg.
//   $_FILE_DATA[0]->name  or  $_FILE_DATA[0]->getFileInfo('name')
/////////////////////////////////////////////////////////////////////////////////////////////////





//Create a '<tr><td>' string based on file upload data 
$_FILE_DATA_TABLE = getFileDataTable($_FILE_DATA, $_CONFIG_DATA);

// Create and send email
if($_CONFIG_DATA['send_email_on_upload']){
	$_FILE_DATA_EMAIL = getFileDataEmail($_FILE_DATA, $_CONFIG_DATA);
	ob_implicit_flush(1);
	emailUploadResults($_FILE_DATA_EMAIL, $_CONFIG_DATA, $_POST_DATA);  
}

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
  <head>
    <title>Uber-Uploader - Free File Upload Progress Bar</title>
    <meta http-equiv="content-type" content="text/html; charset=utf-8">
    <meta http-equiv="pragma" content="no-cache">
    <meta http-equiv="cache-control" content="no-cache">
    <meta http-equiv="expires" content="-1">
    <meta name="robots" content="none">
  </head>
  
  <?php if(isset($_CONFIG_DATA['embedded_upload_results']) && $_CONFIG_DATA['embedded_upload_results'] == 1){ ?>
  <script language="javascript" type="text/javascript">
      parent.document.getElementById('upload_div').style.display = "";
      parent.iniFilePage();
  </script>
  <?php } ?>
  
  <body style="background-color: #EEEEEE; color: #000000; font-family: arial, helvetica, sans_serif;">
    <br>
    <div align="center">
      <br>
      <table cellpadding="1" cellspacing="1" width="70%" >
        <tr>
          <td align="center" bgcolor="bbbbbb">&nbsp;&nbsp;<b>UPLOADED FILE NAME</b>&nbsp;&nbsp;</td><td align="center" bgcolor="bbbbbb">&nbsp;&nbsp;<b>UPLOADED FILE SIZE</b>&nbsp;&nbsp;</td>
        </tr>
        <?php print $_FILE_DATA_TABLE; ?>
      </table>
      <br>
       <?php if(!isset($_CONFIG_DATA['embedded_upload_results']) || $_CONFIG_DATA['embedded_upload_results'] != 1){ ?>
       <br>
       <input type="button" value="Go Back" onClick="javascript:location.href='uu_file_upload.php'">
       <?php } ?>
    </div>
  </body>
</html>
